;***************************************************
;*	L@ELfBXvCڃbJIS				*
;*	[OLEDbJXCb` IS-18WWC1W({J)]	*
;*			Ɩf gZVersion			*
;*											*
;*   Filename:IS-18_Demo-kit_CQ					*
;*    Date:2010.12.10							*
;*    File Version:1.0							*
;*											*
;***************************************************
	LIST	P=18F252
	#include "P18F252.INC"
;****	PIC Configration Bits Setup 	 ****
__CONFIG	_CONFIG1H, _OSCS_OFF_1H & _HS_OSC_1H									;Oscillator MODE HS 4MHz
__CONFIG	_CONFIG2L, _BORV_20_2L & _BOR_OFF_2L & _PWRT_OFF_2L						;Brown out Reset = OFF
__CONFIG	_CONFIG2H, _WDTPS_1_2H & _WDT_OFF_2H									;Watchdog Timer = OFF
__CONFIG	_CONFIG3H, _CCP2MX_ON_3H											;CCP2 = RC1
__CONFIG	_CONFIG4L, _DEBUG_OFF_4L & _LVP_OFF_4L & _STVR_ON_4L					;Low Voltage ICP = OFF
__CONFIG	_CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L			;ALL = OFF
__CONFIG	_CONFIG5H, _CPD_OFF_5H & _CPB_OFF_5H									;ALL = OFF
__CONFIG	_CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L		;ALL = OFF
__CONFIG	_CONFIG6H, _WRTD_OFF_6H & _WRTB_OFF_6H & _WRTC_OFF_6H					;ALL = OFF
__CONFIG	_CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L	;ALL = OFF
__CONFIG 	_CONFIG7H, _EBTRB_OFF_7H											;ALL = OFF

;****	ϐ`		 ****
#DEFINE	XCS	LATC,1		;`bvZNg
#DEFINE	AO	LATC,0		;AhX
#DEFINE	XRES	LATC,2		;Zbg
#DEFINE	SHDN	LATC,6		;VccVbg_E
#DEFINE	FET	LATC,7		;VddVbg_E
#DEFINE	SW3	PORTB,0		;㑤XCb`
#DEFINE	SW2	PORTB,1		;XCb`
#DEFINE	SW1	PORTB,2		;XCb`
#DEFINE	BUZ	LATB,7		;uU[
#DEFINE	ROOM1 LATA,0		;1_LED
#DEFINE	ROOM2 LATA,1		;2_LED
#DEFINE	ROOM3 LATA,2		;3_LED
#DEFINE	ROOM4 LATA,3		;4_LED
#DEFINE	ROOM5 LATB,6		;5_LED
CNT1		EQU	1			;1msJE^p
CNT2		EQU	2			;10msJE^p_1
CNT3		EQU	3			;10msJE^p_2
CNT4		EQU	4			;100msJE^p_1
CNT5		EQU	5			;100msJE^p_2
CNT6		EQU	6			;1sJE^p_1
CNT7		EQU	7			;1sJE^p_2
CNT8		EQU	8			;1sJE^p_3
CNT9		EQU	9			;ʃf[^Ăяop_1
CNT10	EQU	10			;ʃf[^Ăяop_2
DNM1		EQU	11			;p_ʇp
DNM2		EQU	12			;p_ʇp(⏕)
RPS		EQU	13			;p_e_
ONOFF	EQU	14			;p_ON/OFFI
DIS		EQU	15			;p_\

	ORG	00000H

;******************************************************
;	CvO
;******************************************************
START	;|[gݒ
	CLRF	PORTA		;|[gA̓NA
	CLRF	LATA			;|[gAo̓NA
	MOVLW	0FH			;SfW^
	MOVWF	ADCON1		;|[gA A/Dݒ
	MOVLW	10H			;RA0-3,o,RA4͐ݒ
	MOVWF	TRISA		;|[gA0-3o͐ݒ
	CLRF	PORTB		;|[gB̓NA
	CLRF	LATB			;|[gBo̓NA
	MOVLW	0FH			;RB0-34-7o͐ݒl
	MOVWF	TRISB		;|[gB0-3͐ݒ
	CLRF	PORTC		;|[gC̓NA
	CLRF	LATC			;|[gCo̓NA
	BSF		FET			;Vdd=OFF
	BSF		BUZ			;uU[=OFF		
	MOVLW	10H			;RC4͐ݒl
	MOVWF	TRISC		;|[gC4͐ݒ

SPI	;***	SPIݒ	***
	MOVLW	20H			;
	MOVWF	SSPCON1		;FOSC/4,MASTER,CKP=0
	MOVLW	40H			;
	MOVWF	SSPSTAT		;SMP=0,CKE=1

	;*** ϐݒ	***
INITIAL_VALUE
	MOVLW	03H			;3=SON\
	MOVWF	DNM1			;ʇݒ
	MOVLW	05H			;
	MOVWF	DNM2			;ʇݒ(⏕)
	MOVLW	10H			;SOFF
	MOVWF	RPS			;e_Ԑݒ
	MOVLW	00H			;\
	MOVWF	DIS			;\ސݒ
	RCALL	ON_SEQ		;ONV[PX

	;***	\f[^AhXݒ	***		
DNM_DETECT1
	BTFSS	DNM1,2
	BRA		DNM_DETECT3
	BTFSS	DNM1,1
	BRA		DNM_DETECT2
	BTFSC	DNM1,0
	BRA		DNM_7		;7
	BRA		DNM_6		;6

DNM_DETECT2
	BTFSC	DNM1,0
	BRA	DNM_5			;5
	BRA	DNM_4			;4

DNM_DETECT3
	BTFSS	DNM1,1
	BRA	DNM_1			;1
	BTFSC	DNM1,0
	BRA	DNM_3			;3
	BRA	DNM_2			;2

	;***	e[u	|C^Zbg	***
DNM_1					;1=m
	MOVLW	UPPER 01000H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01000H
	MOVWF	TBLPTRH
	MOVLW	LOW 01000H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_2					;2=rO
	MOVLW	UPPER 01200H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01200H
	MOVWF	TBLPTRH
	MOVLW	LOW 01200H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_3					;3=S
	MOVLW	UPPER 01400H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01400H
	MOVWF	TBLPTRH
	MOVLW	LOW 01400H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_4					;4=S
	MOVLW	UPPER 01400H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01400H
	MOVWF	TBLPTRH
	MOVLW	LOW 01400H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_5					;5=
	MOVLW	UPPER 01600H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01600H
	MOVWF	TBLPTRH
	MOVLW	LOW 01600H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_6					;6=Q
	MOVLW	UPPER 01800H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01800H
	MOVWF	TBLPTRH
	MOVLW	LOW 01800H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

DNM_7					;7=a
	MOVLW	UPPER 01A00H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01A00H
	MOVWF	TBLPTRH
	MOVLW	LOW 01A00H
	MOVWF	TBLPTRL
	BRA		DB_TRANS1

	;***	eON/OFFԌo	***	
ONOFF_DETECT1
	MOVLW	01H
	MOVWF	DIS			;ON/OFF\ݒ			
	BTFSS	DNM1,2
	BRA		ONOFF_DETECT3
	BTFSS	DNM1,1
	BRA		ONOFF_DETECT2
	BTFSC	DNM1,0
	BRA		ROOM_7		;7
	BRA		ROOM_6		;6

ONOFF_DETECT2
	BTFSC	DNM1,0
	BRA		ROOM_5		;5
	BRA		ROOM_4		;4

ONOFF_DETECT3
	BTFSS	DNM1,1
	BRA		ROOM_1		;1
	BTFSC	DNM1,0
	BRA		ROOM_3		;3
	BRA		ROOM_2		;2

ROOM_1
	BTFSC	RPS,1		;OFFH
	BRA		ROOM_1ON
	BCF		ROOM1		;OFF()
	BRA		ONOFF_ON		;ON\
ROOM_1ON
	BSF		ROOM1		;ON(_)
	BRA		ONOFF_OFF		;OFF\
ROOM_2
	BTFSC	RPS,2		;ONH
	BRA		ROOM_2ON
	BCF		ROOM2		;OFF()
	BRA		ONOFF_ON		;ON\
ROOM_2ON
	BSF		ROOM2		;ON(_)
	BRA		ONOFF_OFF		;OFF\
ROOM_3
	RCALL	ALL_ROOM_ONOFF;SON(_)
	BRA		ONOFF_ON		;ON\
ROOM_4
	RCALL	ALL_ROOM_ONOFF;SOFF()
	BRA		ONOFF_OFF		;OFF\
ROOM_5
	BTFSC	RPS,5		;ONH
	BRA		ROOM_5ON
	BCF		ROOM3		;OFF()
	BRA		ONOFF_ON		;ON\
ROOM_5ON
	BSF		ROOM3		;ON(_)
	BRA		ONOFF_OFF		;OFF\
ROOM_6
	BTFSC	RPS,6		;ONH
	BRA		ROOM_6ON
	BCF		ROOM4		;OFF()
	BRA		ONOFF_ON		;ON\
ROOM_6ON
	BSF		ROOM4		;ON(_)
	BRA		ONOFF_OFF		;OFF\
ROOM_7
	BTFSC	RPS,7		;ONH
	BRA		ROOM_7ON
	BCF		ROOM5		;OFF()
	BRA		ONOFF_ON		;ON\
ROOM_7ON
	BSF		ROOM5		;ON(_)
	BRA		ONOFF_OFF		;OFF\

	;***	ON/OFF\e[u|C^ݒ	***	
ONOFF_ON
	MOVLW	UPPER 01C00H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01C00H
	MOVWF	TBLPTRH
	MOVLW	LOW 01C00H
	MOVWF	TBLPTRL
	BRA		DB_TRANS2

ONOFF_OFF
	MOVLW	UPPER 01E00H
	MOVWF	TBLPTRU
	MOVLW	HIGH 01E00H
	MOVWF	TBLPTRH
	MOVLW	LOW 01E00H
	MOVWF	TBLPTRL
	BRA		DB_TRANS2
	
	;*** SON/OFFI	***
ALL_ROOM_ONOFF
ROOM_A1
	BTFSC	RPS,1		;ON?
	BRA		ROOM_A1ON
	BCF		ROOM1		;OFF()
	BRA		ROOM_A2
ROOM_A1ON
	BSF		ROOM1		;ON(_)
ROOM_A2
	BTFSC	RPS,2		;ON?
	BRA		ROOM_A2ON
	BCF		ROOM2		;OFF()
	BRA		ROOM_A5
ROOM_A2ON
	BSF		ROOM2		;ON(_)
ROOM_A5
	BTFSC	RPS,5		;ON?
	BRA		ROOM_A5ON
	BCF		ROOM3		;OFF()
	BRA		ROOM_A6
ROOM_A5ON
	BSF		ROOM3		;ON(_)
ROOM_A6
	BTFSC	RPS,6		;ON?
	BRA		ROOM_A6ON
	BCF		ROOM4		;OFF()
	BRA		ROOM_A7
ROOM_A6ON
	BSF		ROOM4		;ON(_)
ROOM_A7
	BTFSC	RPS,7		;ON?
	BRA		ROOM_A7ON
	BCF		ROOM5		;OFF()
	RETURN
ROOM_A7ON
	BSF		ROOM5		;ON(_)
	RETURN	

	;***	uU[ݒ	***
BUZZER_ROOM
	BCF		BUZ			;uU[=ON
	RCALL	TIME100M
	BSF		BUZ			;uU[=OFF

	;***	ON/OFFύXꏊo		***
ONOFF_DETECT11
	BTFSS	DNM1,2
	BRA		ONOFF_DETECT13
	BTFSS	DNM1,1
	BRA		ONOFF_DETECT12
	BTFSC	DNM1,0
	BRA		ROOM_17		;7
	BRA		ROOM_16		;6

ONOFF_DETECT12
	BTFSC	DNM1,0
	BRA		ROOM_15		;5
	BRA		ROOM_14		;4

ONOFF_DETECT13
	BTFSS	DNM1,1
	BRA		ROOM_11		;1
	BTFSC	DNM1,0
	BRA		ROOM_13		;3
	BRA		ROOM_12		;2

	;*** ON/OFFύX	***
ROOM_11
	BTG		RPS,1		;1 ON/OFF]
	BRA		SW_FREE_WAIT
ROOM_12
	BTG		RPS,2		;2 ON/OFF]
	BRA		SW_FREE_WAIT
ROOM_13
	MOVLW	0F6H			;S ON
	MOVWF	RPS
	BRA		SW_FREE_WAIT
ROOM_14
	CLRF	RPS			;S OFF
	BRA		SW_FREE_WAIT
ROOM_15
	BTG		RPS,5		;5 ON/OFF]
	BRA		SW_FREE_WAIT
ROOM_16
	BTG		RPS,6		;6 ON/OFF]
	BRA		SW_FREE_WAIT
ROOM_17
	BTG		RPS,7		;7 ON/OFF]
	BRA		SW_FREE_WAIT
	
	;***	SW_OFF ҂	***
SW_FREE_WAIT		
	BTFSS	SW2,0		;SW2=OFF?
	BRA		$-2
	BTFSS	SW1,0		;SW1=OFF?
	BRA		$-2
	BTFSS	SW3,0		;SW3=OFF?
	BRA		$-2
	BRA		DNM_DETECT1

	;***	f[^Ăяo[v	***
DB_TRANS1
	BCF		XCS			;SS=L
	RCALL	TIME1M
	BCF		AO
	MOVLW	08H			;DataRW
	MOVWF	SSPBUF
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
DB_TRANS2
	BSF		AO
	MOVLW	20H			;32(32s)
	MOVWF	CNT9
D_LP_ROOM
	MOVLW	0CH			;12(12x8=96)
	MOVWF	CNT10
READ_DB_ROOM
	TBLRD	*+
	MOVF	TABLAT,W
	MOVWF	SSPBUF
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	DECFSZ	CNT10,F
	BRA		READ_DB_ROOM
	DECFSZ	CNT9,F
	BRA		D_LP_ROOM
	BTFSS	DIS,0
	BRA		ONOFF_DETECT1
	BCF		AO			;AO=L(R}h)
	MOVLW	02H			;Display ON/OFF
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H(p[^)
	MOVLW	01H			;ON
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		XCS			;SS=H
	MOVLW	00H
	MOVWF	DIS
	BTFSS	SW1,0		;SW1=OFF?
	BRA		$-2
	BTFSS	SW3,0		;SW3=OFF?
	BRA		$-2
	BTFSS	SW2,0		;SW2=OFF?
	BRA		$-2

	;*** XCb`쌟o	***
SW3_DETECT_ROOM
	BTFSC	SW3,0		;㑤XCb`ON?
	BRA		SW1_DETECT_ROOM
	RCALL	TIME10M
	BTFSC	SW3,0		;`^O
	BRA		SW1_DETECT_ROOM
	INCF	DNM2,F		;ʇ+1(⏕)
	DECFSZ	DNM1,F		;ʇ-1
	BRA		DNM_DETECT1
	MOVLW	07H
	MOVWF	DNM1
	MOVLW	01H
	MOVWF	DNM2
	BRA		DNM_DETECT1
	
SW1_DETECT_ROOM
	BTFSC	SW1,0			;XCb`ON?
	BRA		SW2_DETECT_ROOM
	RCALL	TIME10M
	BTFSC	SW1,0			;`^O
	BRA		SW2_DETECT_ROOM
	INCF	DNM1,F			;ʇ+1
	DECFSZ	DNM2,F			;ʇ-1(⏕)
	BRA		DNM_DETECT1
	MOVLW	01H
	MOVWF	DNM1
	MOVLW	07H
	MOVWF	DNM2
	BRA		DNM_DETECT1

SW2_DETECT_ROOM
	BTFSC	SW2,0			;XCb`ON?
	BRA		SW3_DETECT_ROOM
	RCALL	TIME10M
	BTFSC	SW2,0			;`^O
	BRA		SW3_DETECT_ROOM
	BRA		BUZZER_ROOM

;******************************************************
;	fBC^C}[Tu[`
;	NbN4MHz 1msp
;******************************************************
TIME1M
	MOVLW	0F9	;250
	MOVWF	CNT1
T_LP1	NOP
		NOP
		DECFSZ	CNT1,F
		BRA		T_LP1
		RETURN
;******************************************************

;******************************************************
;	fBC^C}[Tu[`
;	NbN4MHz 10msp
;******************************************************
TIME10M
	MOVLW	0AH		;10
	MOVWF	CNT2
T_LP2
	MOVLW	0F9H		;250
	MOVWF	CNT3
T_LP3	NOP
		NOP
		DECFSZ	CNT3,F
		BRA		T_LP3
		DECFSZ	CNT2,F
		BRA		T_LP2
		RETURN
;******************************************************

;******************************************************
;	fBC^C}[Tu[`
;	NbN4MHz 100msp
;******************************************************
TIME100M
	MOVLW	64H		;100
	MOVWF	CNT4
T_LP4
	MOVLW	0F9H		;250
	MOVWF	CNT5
T_LP5	NOP
		NOP
		DECFSZ	CNT5,F
		BRA		T_LP5
		DECFSZ	CNT4,F
		BRA		T_LP4
		RETURN
;******************************************************

;******************************************************
;	fBC^C}[Tu[`
;	NbN4MHz 1sp
;******************************************************
TIME1S
	MOVLW	0AH	;10
	MOVWF	CNT6
T_LP6
	MOVLW	64H	;100
	MOVWF	CNT7
T_LP7
	MOVLW	0F9H	;250
	MOVWF	CNT8
T_LP8	NOP
		NOP
		DECFSZ	CNT8,F
		BRA		T_LP8
		DECFSZ	CNT7,F
		BRA		T_LP7
		DECFSZ	CNT6,F
		BRA		T_LP6
		RETURN
;******************************************************

;******************************************************
;	ONV[PX
;******************************************************
ON_SEQ
	BCF		FET			;Vdd=ON
	BSF		XCS			;SS=H
	BSF		SHDN			;Vcc=ON
	RCALL	TIME1M		;1msJE^[v
	RCALL	TIME1M		;1msJE^[v
	RCALL	TIME1M		;1msJE^[v	
	BSF		XRES			;RES=H
	RCALL	TIME1M		;1msJE^[v
	BCF		BUZ			;uU[=ON
	RCALL	TIME10M		;10msJE^[v
	BSF		BUZ			;uU[=OFF
	RCALL	TIME1S		;1sJE^[v
	RCALL	OLED_INI		;OLEDݒ

;******************************************************
;	OLEDR}h
;******************************************************
OLED_INI
	BCF		XCS			;XCS=L
	BCF		AO			;AO=L(AhX)
	MOVLW	01H			;SOFTRES
	MOVWF	SSPBUF		;SPIM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		XCS			;XCS=H
	RCALL	TIME1M
	BCF		XCS			;XCS=L
	BCF		AO			;AO=L(AhX)
	MOVLW	02H			;Display ON/OFF
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H(p[^)
	MOVLW	00H			;OFF
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	07H			;ReadOperation
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;READ
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	14H			;Stand-By ON/OFF
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;OFF
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D0H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	80H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D2H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D4H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D5H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D6H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D7H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0D9H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0DBH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	0FH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0DDH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	8AH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
;
	BCF		AO			;AO=L
	MOVLW	1AH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	04H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	1DH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	09H			;Display Direction
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	30H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	MOVLW	5FH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	32H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	MOVLW	3FH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	38H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	39H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	34H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	35H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	0BH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	36H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	37H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	3FH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
;	
	BCF		AO			;AO=L
	MOVLW	10H			;Reserved1
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	03H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	16H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	12H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	92H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	18H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	09H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	48H			;
	MOVWF	SSPBUF		;SPIM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	03H			;
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	17H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	13H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	1CH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0C3H			;
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0C4H			;
	MOVWF	SSPBUF		;SPIʐM
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0CCH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	0CDH			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BCF		AO			;AO=L
	MOVLW	14H			;Stand-By ON/OFF
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		AO			;AO=H
	MOVLW	00H			;OFF
	MOVWF	SSPBUF		;
	BTFSS	SSPSTAT,BF	;MmF
	BRA		$-2			;M҂
	BSF		XCS			;SS=H
	RCALL	TIME1M
	RETURN

;***	\f[^ 1 m	***
	ORG	01000H
DNM_01
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,30H,00H,00H
	DB	01H,81H,0C0H,1CH,00H,00H,00H,00H,00H,70H,00H,00H,01H,0C0H,0E0H,3CH
	DB	00H,00H,00H,00H,00H,70H,00H,00H,00H,0E0H,0F0H,78H,00H,00H,00H,03H
	DB	0FFH,0FFH,0FFH,00H,00H,0F0H,70H,70H,00H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	00H,77H,0FFH,0FFH,00H,00H,00H,03H,80H,00H,07H,00H,00H,07H,0FFH,0FFH
	DB	00H,00H,00H,03H,80H,00H,07H,00H,00H,00H,07H,00H,00H,00H,00H,03H
	DB	0BFH,0FFH,0FFH,00H,03H,80H,07H,00H,00H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	01H,0C0H,07H,00H,00H,00H,00H,00H,03H,83H,00H,00H,01H,0E0H,07H,00H
	DB	00H,00H,00H,00H,07H,03H,0C0H,00H,00H,0F0H,07H,00H,00H,00H,00H,00H
	DB	0EH,00H,0F0H,00H,00H,73H,0FFH,0FEH,00H,00H,00H,00H,1CH,00H,78H,00H
	DB	00H,03H,0FFH,0FEH,00H,00H,00H,01H,0FFH,0FFH,0FEH,00H,00H,00H,07H,00H
	DB	00H,00H,00H,01H,0FFH,0F0H,0FH,00H,00H,00H,07H,00H,00H,00H,00H,00H
	DB	00H,70H,07H,00H,00H,30H,07H,00H,00H,00H,00H,00H,00H,70H,00H,00H
	DB	00H,70H,07H,00H,00H,00H,00H,00H,00H,70H,00H,00H,00H,70H,07H,00H
	DB	00H,00H,00H,01H,0FFH,0FFH,0FEH,00H,00H,0EFH,0FFH,0FFH,80H,00H,00H,01H
	DB	0FFH,0FFH,0FEH,00H,00H,0EFH,0FFH,0FFH,00H,00H,00H,00H,00H,70H,00H,00H
	DB	01H,0E0H,07H,00H,00H,00H,00H,00H,00H,70H,00H,00H,01H,0C0H,07H,00H
	DB	00H,00H,00H,00H,00H,70H,00H,00H,03H,0C0H,07H,00H,00H,00H,00H,00H
	DB	00H,70H,00H,00H,03H,80H,07H,00H,00H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	03H,00H,07H,00H,00H,00H,00H,03H,0FFH,0FFH,0FFH,80H,00H,00H,06H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,40H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ 2 rO		***
	ORG	01200H
DNM_02
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,50H,00H,00H,00H,00H,00H,90H,00H,00H,00H,02H,00H,68H
	DB	30H,01H,80H,60H,00H,58H,00H,00H,00H,02H,00H,2CH,30H,01H,80H,60H
	DB	00H,48H,78H,00H,00H,07H,0FFH,0B4H,30H,01H,80H,60H,00H,20H,3EH,00H
	DB	00H,07H,0FFH,0C0H,30H,01H,80H,60H,01H,0C0H,0FH,00H,10H,06H,00H,0E0H
	DB	30H,01H,80H,60H,07H,0C0H,03H,80H,30H,0CH,00H,60H,30H,01H,80H,60H
	DB	3FH,00H,01H,0C0H,30H,0CH,00H,40H,30H,01H,80H,63H,0F8H,00H,00H,00H
	DB	20H,18H,00H,0C0H,30H,01H,80H,7FH,80H,00H,00H,00H,60H,30H,00H,0C0H
	DB	30H,01H,80H,70H,00H,00H,00H,00H,60H,60H,00H,0C0H,30H,01H,80H,60H
	DB	00H,00H,00H,00H,0C0H,0C0H,01H,80H,30H,01H,80H,60H,00H,00H,00H,01H
	DB	0C0H,00H,01H,80H,30H,01H,80H,60H,00H,00H,00H,01H,80H,00H,03H,00H
	DB	00H,01H,80H,60H,00H,00H,00H,03H,00H,00H,06H,00H,00H,01H,80H,60H
	DB	00H,00H,00H,06H,00H,00H,0EH,00H,00H,03H,00H,60H,00H,00H,00H,1CH
	DB	00H,00H,1CH,00H,00H,03H,00H,60H,00H,00H,00H,38H,00H,00H,38H,00H
	DB	00H,06H,00H,30H,00H,00H,01H,0F0H,00H,00H,0E0H,00H,00H,1CH,00H,3FH
	DB	0FFH,0F0H,3FH,0C0H,00H,07H,80H,00H,03H,0F0H,00H,1FH,0FFH,0E0H,3EH,00H
	DB	00H,3EH,00H,00H,03H,80H,00H,00H,00H,00H,00H,00H,00H,20H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ 3 S	***
	ORG	01400H
DNM_03
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,0E0H,00H,00H,00H,00H,06H,00H,00H,00H
	DB	00H,00H,01H,0F0H,00H,00H,00H,00H,06H,00H,00H,00H,00H,00H,03H,0BCH
	DB	00H,00H,00H,3FH,0FFH,0FFH,0E0H,00H,00H,00H,07H,1EH,00H,00H,00H,7FH
	DB	0FFH,0FFH,0F0H,00H,00H,00H,1EH,07H,00H,00H,00H,60H,00H,00H,30H,00H
	DB	00H,00H,38H,03H,0C0H,00H,00H,60H,00H,00H,30H,00H,00H,00H,0F0H,00H
	DB	0F0H,00H,00H,60H,00H,00H,30H,00H,00H,03H,0C0H,00H,7CH,00H,00H,67H
	DB	0FFH,0FFH,30H,00H,00H,0FH,80H,00H,1FH,00H,00H,67H,0FFH,0FFH,30H,00H
	DB	00H,1CH,00H,00H,06H,00H,00H,00H,70H,30H,00H,00H,00H,01H,0FFH,0FFH
	DB	0F0H,00H,00H,00H,0E0H,1CH,00H,00H,00H,01H,0FFH,0FFH,0F0H,00H,00H,00H
	DB	0C0H,0EH,00H,00H,00H,00H,00H,0C0H,00H,00H,00H,03H,80H,03H,80H,00H
	DB	00H,00H,00H,0C0H,00H,00H,00H,07H,0FFH,0FFH,0C0H,00H,00H,00H,00H,0C0H
	DB	00H,00H,00H,3FH,0FFH,0F8H,0E0H,00H,00H,00H,00H,0C0H,00H,00H,00H,00H
	DB	06H,00H,70H,00H,00H,00H,00H,0C0H,00H,00H,00H,00H,06H,00H,00H,00H
	DB	00H,01H,0FFH,0FFH,0F0H,00H,00H,00H,06H,00H,00H,00H,00H,01H,0FFH,0FFH
	DB	0F0H,00H,00H,00H,06H,00H,00H,00H,00H,00H,00H,0C0H,00H,00H,00H,3FH
	DB	0FFH,0FFH,0E0H,00H,00H,00H,00H,0C0H,00H,00H,00H,1FH,0FFH,0FFH,0C0H,00H
	DB	00H,00H,00H,0C0H,00H,00H,00H,00H,06H,00H,00H,00H,00H,00H,00H,0C0H
	DB	00H,00H,00H,00H,06H,00H,00H,00H,00H,00H,00H,0C0H,00H,00H,00H,00H
	DB	06H,00H,00H,00H,00H,00H,00H,0C0H,00H,00H,00H,00H,06H,00H,00H,00H
	DB	00H,0FH,0FFH,0FFH,0FEH,00H,00H,7FH,0FFH,0FFH,0F0H,00H,00H,0FH,0FFH,0FFH
	DB	0FEH,00H,00H,7FH,0FFH,0FFH,0F8H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ 5 	***
	ORG	01600H
DNM_05
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,18H,00H,00H,01H,0C0H,30H,0E0H
	DB	00H,00H,00H,00H,00H,38H,00H,00H,01H,0E0H,70H,0F0H,00H,00H,00H,00H
	DB	00H,38H,00H,00H,00H,0F0H,0F0H,78H,00H,00H,00H,01H,0FFH,0FFH,0FFH,80H
	DB	00H,71H,0E0H,3CH,00H,00H,00H,01H,0FFH,0FFH,0FFH,80H,00H,33H,0C0H,0EH
	DB	00H,00H,00H,01H,0C0H,00H,03H,80H,00H,07H,86H,07H,00H,00H,00H,01H
	DB	0C0H,00H,03H,80H,00H,06H,0FH,00H,00H,00H,00H,01H,0DFH,0FFH,0FFH,80H
	DB	03H,80H,1FH,80H,00H,00H,00H,01H,0FFH,0FFH,0FFH,80H,03H,0C0H,3DH,0C0H
	DB	00H,00H,00H,00H,01H,0C1H,80H,00H,01H,0E0H,78H,0F0H,00H,00H,00H,00H
	DB	03H,81H,0E0H,00H,00H,0E0H,0F0H,78H,00H,00H,00H,00H,07H,00H,78H,00H
	DB	00H,71H,0E0H,3EH,00H,00H,00H,00H,0EH,00H,3CH,00H,00H,03H,0C0H,1FH
	DB	00H,00H,00H,00H,0FFH,0FFH,0FFH,00H,00H,0FH,00H,07H,80H,00H,00H,00H
	DB	0FFH,0F8H,07H,80H,00H,0CH,0FFH,0F8H,00H,00H,00H,00H,00H,38H,03H,80H
	DB	00H,03H,0FFH,0FCH,00H,00H,00H,00H,00H,38H,00H,00H,00H,73H,80H,1CH
	DB	00H,00H,00H,00H,00H,38H,00H,00H,00H,73H,80H,1CH,00H,00H,00H,00H
	DB	0FFH,0FFH,0FFH,00H,00H,0E3H,80H,1CH,00H,00H,00H,00H,0FFH,0FFH,0FFH,00H
	DB	00H,0E3H,80H,1CH,00H,00H,00H,00H,00H,38H,00H,00H,00H,0E3H,80H,1CH
	DB	00H,00H,00H,00H,00H,38H,00H,00H,01H,0C3H,80H,1CH,00H,00H,00H,00H
	DB	00H,38H,00H,00H,01H,0C3H,80H,1CH,00H,00H,00H,00H,00H,38H,00H,00H
	DB	03H,83H,0FFH,0FCH,00H,00H,00H,01H,0FFH,0FFH,0FFH,80H,03H,81H,0FFH,0FCH
	DB	00H,00H,00H,01H,0FFH,0FFH,0FFH,0C0H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ 6 Q	***
	ORG	01800H
DNM_06
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,30H,00H,00H,00H,00H,00H,00H,30H,00H,00H
	DB	00H,00H,38H,00H,00H,00H,00H,00H,00H,70H,00H,00H,01H,0FFH,0FFH,0FEH
	DB	00H,00H,00H,00H,00H,70H,00H,00H,07H,0FFH,0FFH,0FFH,00H,00H,00H,03H
	DB	0FFH,0FFH,0FFH,00H,07H,00H,00H,03H,80H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	07H,30H,00H,03H,80H,00H,00H,03H,80H,00H,07H,00H,07H,71H,0FFH,0FFH
	DB	80H,00H,00H,03H,80H,00H,07H,00H,07H,70H,00H,1FH,00H,00H,00H,03H
	DB	0BFH,0FFH,0FFH,00H,00H,70H,00H,1CH,00H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	03H,71H,0FFH,0FCH,00H,00H,00H,00H,03H,83H,00H,00H,03H,70H,00H,1CH
	DB	00H,00H,00H,00H,07H,03H,0C0H,00H,03H,0F0H,00H,1CH,00H,00H,00H,00H
	DB	0EH,00H,0F0H,00H,03H,0F1H,0FFH,0F8H,00H,00H,00H,00H,1CH,00H,78H,00H
	DB	03H,0F0H,00H,00H,00H,00H,00H,01H,0FFH,0FFH,0FEH,00H,01H,0F1H,0FFH,0FEH
	DB	00H,00H,00H,01H,0FFH,0F0H,0FH,00H,01H,0F7H,0FFH,0FFH,00H,00H,00H,00H
	DB	00H,70H,07H,00H,00H,77H,00H,03H,80H,00H,00H,00H,00H,70H,00H,00H
	DB	00H,77H,00H,03H,80H,00H,00H,00H,00H,70H,00H,00H,00H,77H,0FFH,0FBH
	DB	80H,00H,00H,01H,0FFH,0FFH,0FEH,00H,00H,76H,38H,3BH,80H,00H,00H,01H
	DB	0FFH,0FFH,0FEH,00H,01H,0F0H,1CH,78H,00H,00H,00H,00H,00H,70H,00H,00H
	DB	03H,0F0H,0EH,0F0H,00H,00H,00H,00H,00H,70H,00H,00H,07H,0F0H,07H,0E0H
	DB	00H,00H,00H,00H,00H,70H,00H,00H,00H,70H,07H,0E0H,00H,00H,00H,00H
	DB	00H,70H,00H,00H,00H,70H,7EH,0FEH,00H,00H,00H,03H,0FFH,0FFH,0FFH,00H
	DB	00H,77H,0F0H,3FH,80H,00H,00H,03H,0FFH,0FFH,0FFH,80H,00H,30H,00H,03H
	DB	00H,00H,00H,00H,00H,00H,00H,40H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ 7 a	***
	ORG	01A00H
DNM_07
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,0C0H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,70H,00H,00H,00H,00H,00H,00H,78H,00H,00H,00H,00H,0F0H,00H
	DB	00H,00H,00H,00H,00H,38H,00H,00H,00H,03H,0F0H,00H,00H,00H,00H,00H
	DB	00H,38H,1EH,00H,00H,07H,80H,00H,00H,00H,00H,00H,30H,3FH,0FFH,00H
	DB	00H,1FH,80H,00H,00H,00H,00H,00H,3FH,0F0H,0FH,80H,00H,73H,80H,00H
	DB	00H,00H,00H,00H,70H,00H,1EH,00H,00H,03H,80H,00H,00H,00H,00H,00H
	DB	0E0H,07H,30H,00H,00H,03H,0BCH,00H,00H,00H,00H,00H,0E0H,1FH,80H,00H
	DB	00H,03H,0FEH,00H,00H,00H,00H,00H,0E1H,0FCH,00H,00H,00H,1FH,80H,07H
	DB	0C0H,00H,00H,00H,03H,0E0H,00H,00H,01H,0F3H,86H,7FH,0F0H,00H,00H,00H
	DB	00H,0E0H,00H,00H,00H,07H,87H,0C1H,0E0H,00H,00H,00H,00H,0E7H,00H,00H
	DB	00H,0FH,0C7H,01H,0E0H,00H,00H,00H,01H,0C3H,0C0H,00H,00H,0FH,0FBH,81H
	DB	0C0H,00H,00H,00H,01H,0BFH,0C0H,00H,00H,1FH,0BBH,83H,0C0H,00H,00H,00H
	DB	1FH,0F0H,0E0H,00H,00H,3BH,9BH,83H,0C0H,00H,00H,00H,3FH,0B8H,00H,00H
	DB	00H,33H,83H,83H,80H,00H,00H,00H,0CH,38H,00H,00H,00H,63H,83H,0BFH
	DB	80H,00H,00H,00H,00H,3FH,0C0H,00H,00H,0C3H,81H,0F0H,00H,00H,00H,00H
	DB	00H,0FFH,0E0H,00H,01H,83H,81H,0C0H,00H,00H,00H,00H,0FH,0F8H,00H,00H
	DB	03H,03H,80H,00H,00H,00H,00H,00H,00H,38H,00H,00H,00H,03H,80H,00H
	DB	00H,00H,00H,00H,00H,38H,00H,00H,00H,03H,80H,00H,00H,00H,00H,00H
	DB	00H,38H,0FEH,00H,00H,03H,80H,00H,00H,00H,00H,00H,00H,0FFH,0FFH,00H
	DB	00H,03H,80H,00H,00H,00H,00H,00H,7FH,0C0H,00H,00H,00H,01H,80H,00H
	DB	00H,00H,00H,00H,0F0H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ ON	***
	ORG	01C00H
LIGHT_ON
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,3FH
	DB	80H,00H,00H,7FH,00H,7CH,00H,00H,00H,00H,01H,0FFH,0F0H,00H,00H,7FH
	DB	80H,7CH,00H,00H,00H,00H,03H,0FFH,0F8H,00H,00H,7FH,80H,7CH,00H,00H
	DB	00H,00H,07H,0FFH,0FCH,00H,00H,7FH,0C0H,7CH,00H,00H,00H,00H,0FH,0E0H
	DB	0FEH,00H,00H,7FH,0E0H,7CH,00H,00H,00H,00H,1FH,0C0H,7FH,00H,00H,7FH
	DB	0E0H,7CH,00H,00H,00H,00H,1FH,80H,3FH,00H,00H,7FH,0F0H,7CH,00H,00H
	DB	00H,00H,1FH,80H,3FH,00H,00H,7FH,0F8H,7CH,00H,00H,00H,00H,3FH,00H
	DB	1FH,80H,00H,7DH,0F8H,7CH,00H,00H,00H,00H,3FH,00H,1FH,80H,00H,7DH
	DB	0FCH,7CH,00H,00H,00H,00H,3FH,00H,1FH,80H,00H,7CH,0FEH,7CH,00H,00H
	DB	00H,00H,3FH,00H,1FH,80H,00H,7CH,7EH,7CH,00H,00H,00H,00H,3FH,00H
	DB	1FH,80H,00H,7CH,7FH,7CH,00H,00H,00H,00H,3FH,00H,1FH,80H,00H,7CH
	DB	3FH,0FCH,00H,00H,00H,00H,3FH,00H,1FH,80H,00H,7CH,1FH,0FCH,00H,00H
	DB	00H,00H,3FH,00H,1FH,80H,00H,7CH,1FH,0FCH,00H,00H,00H,00H,1FH,80H
	DB	3FH,00H,00H,7CH,0FH,0FCH,00H,00H,00H,00H,1FH,80H,3FH,00H,00H,7CH
	DB	0FH,0FCH,00H,00H,00H,00H,1FH,0C0H,7FH,00H,00H,7CH,07H,0FCH,00H,00H
	DB	00H,00H,0FH,0E0H,0FEH,00H,00H,7CH,03H,0FCH,00H,00H,00H,00H,07H,0FFH
	DB	0FCH,00H,00H,7CH,03H,0FCH,00H,00H,00H,00H,03H,0FFH,0F8H,00H,00H,7CH
	DB	01H,0FCH,00H,00H,00H,00H,01H,0FFH,0F0H,00H,00H,7CH,00H,0FCH,00H,00H
	DB	00H,00H,00H,3FH,80H,00H,00H,7CH,00H,0FCH,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;***	\f[^ OFF	***
	ORG	01E00H
LIGHT_OFF
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,0FEH
	DB	00H,0FH,0FFH,0F8H,7FH,0FFH,0C0H,00H,00H,00H,07H,0FFH,0C0H,0FH,0FFH,0F8H
	DB	7FH,0FFH,0C0H,00H,00H,00H,0FH,0FFH,0E0H,0FH,0FFH,0F8H,7FH,0FFH,0C0H,00H
	DB	00H,00H,1FH,0FFH,0F0H,0FH,0FFH,0F8H,7FH,0FFH,0C0H,00H,00H,00H,3FH,83H
	DB	0F8H,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,7FH,01H,0FCH,0FH,0C0H,00H
	DB	7EH,00H,00H,00H,00H,00H,7EH,00H,0FCH,0FH,0C0H,00H,7EH,00H,00H,00H
	DB	00H,00H,7EH,00H,0FCH,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,0FCH,00H
	DB	7EH,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,0FCH,00H,7EH,0FH,0FFH,0F0H
	DB	7FH,0FFH,80H,00H,00H,00H,0FCH,00H,7EH,0FH,0FFH,0F0H,7FH,0FFH,80H,00H
	DB	00H,00H,0FCH,00H,7EH,0FH,0FFH,0F0H,7FH,0FFH,80H,00H,00H,00H,0FCH,00H
	DB	7EH,0FH,0FFH,0F0H,7FH,0FFH,80H,00H,00H,00H,0FCH,00H,7EH,0FH,0C0H,00H
	DB	7EH,00H,00H,00H,00H,00H,0FCH,00H,7EH,0FH,0C0H,00H,7EH,00H,00H,00H
	DB	00H,00H,0FCH,00H,7EH,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,7EH,00H
	DB	0FCH,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,7EH,00H,0FCH,0FH,0C0H,00H
	DB	7EH,00H,00H,00H,00H,00H,7FH,01H,0FCH,0FH,0C0H,00H,7EH,00H,00H,00H
	DB	00H,00H,3FH,83H,0F8H,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,1FH,0FFH
	DB	0F0H,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,0FH,0FFH,0E0H,0FH,0C0H,00H
	DB	7EH,00H,00H,00H,00H,00H,07H,0FFH,0C0H,0FH,0C0H,00H,7EH,00H,00H,00H
	DB	00H,00H,00H,0FEH,00H,0FH,0C0H,00H,7EH,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

	END